#ifndef OPTION_ASDL_H
#define OPTION_ASDL_H

namespace option_asdl {

#define ASDL_NAMES struct
ASDL_NAMES option_i {
  enum no_name {
  errexit = 1,
  nounset = 2,
  pipefail = 3,
  inherit_errexit = 4,
  nullglob = 5,
  verbose_errexit = 6,
  verbose_warn = 7,
  noexec = 8,
  xtrace = 9,
  verbose = 10,
  noglob = 11,
  noclobber = 12,
  errtrace = 13,
  posix = 14,
  vi = 15,
  emacs = 16,
  interactive = 17,
  hashall = 18,
  lastpipe = 19,
  failglob = 20,
  extglob = 21,
  nocasematch = 22,
  dotglob = 23,
  extdebug = 24,
  eval_unsafe_arith = 25,
  ignore_flags_not_impl = 26,
  ignore_shopt_not_impl = 27,
  rewrite_extern = 28,
  _allow_command_sub = 29,
  _allow_process_sub = 30,
  dynamic_scope = 31,
  redefine_const = 32,
  redefine_source = 33,
  _running_trap = 34,
  _running_hay = 35,
  _no_debug_trap = 36,
  _no_err_trap = 37,
  strict_parse_equals = 38,
  strict_parse_slice = 39,
  strict_argv = 40,
  strict_arith = 41,
  strict_array = 42,
  strict_control_flow = 43,
  strict_env_binding = 44,
  strict_errexit = 45,
  strict_nameref = 46,
  strict_word_eval = 47,
  strict_tilde = 48,
  strict_glob = 49,
  parse_at = 50,
  parse_proc = 51,
  parse_func = 52,
  parse_brace = 53,
  parse_bracket = 54,
  parse_equals = 55,
  parse_paren = 56,
  parse_ysh_string = 57,
  parse_triple_quote = 58,
  simple_word_eval = 59,
  dashglob = 60,
  command_sub_errexit = 61,
  process_sub_fail = 62,
  xtrace_rich = 63,
  xtrace_details = 64,
  sigpipe_status_ok = 65,
  env_obj = 66,
  init_ysh_globals = 67,
  for_loop_frames = 68,
  parse_at_all = 69,
  parse_backslash = 70,
  parse_backticks = 71,
  parse_dollar = 72,
  parse_ignored = 73,
  parse_sh_arith = 74,
  parse_dparen = 75,
  parse_dbracket = 76,
  parse_bare_word = 77,
  parse_word_join = 78,
  no_exported = 79,
  no_init_globals = 80,
  simple_echo = 81,
  simple_eval_builtin = 82,
  simple_test_builtin = 83,
  expand_aliases = 84,
  progcomp = 85,
  hostcomplete = 86,
  histappend = 87,
  cmdhist = 88,
  assoc_expand_once = 89,
  autocd = 90,
  cdable_vars = 91,
  cdspell = 92,
  checkhash = 93,
  checkjobs = 94,
  checkwinsize = 95,
  complete_fullquote = 96,
  direxpand = 97,
  dirspell = 98,
  execfail = 99,
  extquote = 100,
  force_fignore = 101,
  globasciiranges = 102,
  globstar = 103,
  gnu_errfmt = 104,
  histreedit = 105,
  histverify = 106,
  huponexit = 107,
  interactive_comments = 108,
  lithist = 109,
  localvar_inherit = 110,
  localvar_unset = 111,
  login_shell = 112,
  mailwarn = 113,
  no_empty_cmd_completion = 114,
  nocaseglob = 115,
  progcomp_alias = 116,
  promptvars = 117,
  restricted_shell = 118,
  shift_verbose = 119,
  sourcepath = 120,
  xpg_echo = 121,
  ARRAY_SIZE = 122,
  };
};

typedef int option_t;

ASDL_NAMES builtin_i {
  enum no_name {
  colon = 1,
  dot = 2,
  exec_ = 3,
  eval = 4,
  set = 5,
  shift = 6,
  times = 7,
  trap = 8,
  unset = 9,
  readonly = 10,
  local = 11,
  declare = 12,
  typeset = 13,
  export_ = 14,
  true_ = 15,
  false_ = 16,
  try_ = 17,
  assert_ = 18,
  break_ = 19,
  continue_ = 20,
  return_ = 21,
  exit = 22,
  read = 23,
  echo = 24,
  printf = 25,
  mapfile = 26,
  readarray = 27,
  cd = 28,
  pushd = 29,
  popd = 30,
  dirs = 31,
  pwd = 32,
  source = 33,
  umask = 34,
  ulimit = 35,
  wait = 36,
  jobs = 37,
  fg = 38,
  bg = 39,
  shopt = 40,
  complete = 41,
  compgen = 42,
  compopt = 43,
  compadjust = 44,
  compexport = 45,
  getopts = 46,
  builtin = 47,
  command = 48,
  type = 49,
  hash = 50,
  help = 51,
  history = 52,
  alias = 53,
  unalias = 54,
  bind = 55,
  append = 56,
  write = 57,
  json = 58,
  json8 = 59,
  pp = 60,
  hay = 61,
  haynode = 62,
  use = 63,
  error = 64,
  failed = 65,
  fork = 66,
  forkwait = 67,
  redir = 68,
  fopen = 69,
  shvar = 70,
  ctx = 71,
  invoke = 72,
  runproc = 73,
  boolstatus = 74,
  test = 75,
  bracket = 76,
  push_registers = 77,
  source_guard = 78,
  is_main = 79,
  cat = 80,
  rm = 81,
  sleep = 82,
  ARRAY_SIZE = 83,
  };
};

typedef int builtin_t;


}  // namespace option_asdl

#endif  // OPTION_ASDL_H
